## xpps-2.3.0-ubuntu17.10.tar

=== Makefile ===
COMPOSER_VER = $(if $(findstring 2018, $(MKLROOT)),2018,2017)
export COMPOSER_VER

all: knc

knc:
	$(MAKE) -C gemm
	$(MAKE) -C shoc
	$(MAKE) -C stream
	$(MAKE) -C micp
	$(MAKE) -C doc

knlsb:
	$(MAKE) -C gemm knlsb
	$(MAKE) -C stream knlsb
	$(MAKE) -C micp knlsb
	$(MAKE) -C doc all
	$(MAKE) -C deepbench intel

knllb:
	$(MAKE) -C gemm knllb
	$(MAKE) -C shoc knllb
	$(MAKE) -C stream knllb
	$(MAKE) -C micp knllb
	$(MAKE) -C doc all

test:
	$(MAKE) -C ut micp_ut

clean:
	$(MAKE) -C gemm clean
	$(MAKE) -C shoc clean
	$(MAKE) -C stream clean
	$(MAKE) -C micp clean
	$(MAKE) -C doc clean
	$(MAKE) -C deepbench clean


ifeq ($(proj_target), knlsb)
install: install-knlsb
else
install: install-knc
endif

install-knc:
	$(MAKE) -C gemm install-knc
	$(MAKE) -C shoc install-knc
	$(MAKE) -C stream install-knc
	$(MAKE) -C micp install-knc
	$(MAKE) -C doc install
	$(MAKE) -C data install-knc

install-knlsb:
	$(MAKE) -C gemm install-knlsb
	$(MAKE) -C stream install-knlsb
	$(MAKE) -C micp install-knlsb
	$(MAKE) -C doc install
	$(MAKE) -C data install-knlsb
	$(MAKE) -C deepbench install

install-knllb:
	$(MAKE) -C gemm install-knllb
	$(MAKE) -C shoc install-knllb
	$(MAKE) -C stream install-knllb
	$(MAKE) -C micp install-knllb
	$(MAKE) -C doc install
	$(MAKE) -C data install-knllb

.PHONY: all knc knllb knlsb gemm shoc stream micp doc clean install install-knc install-knllb install-knlsb test

=== deepbench/Makefile ===
CONVOLUTION_PATH:=code/intel/convolution

all: intel

intel:
	$(MAKE) -C $(CONVOLUTION_PATH) all

clean:
	$(MAKE) -C $(CONVOLUTION_PATH) clean

install:
	$(MAKE) -C $(CONVOLUTION_PATH) install

.PHONY: all intel clean install

=== doc/Makefile ===
# Copyright (c) 2018, Intel Corporation.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.

INSTALL = install
INSTALL_d = $(INSTALL) -d
INSTALL_x = $(INSTALL)
INSTALL_f = $(INSTALL) -m644

.PHONY: all install clean

prefix ?= /usr
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
docdir ?= $(datarootdir)/doc/micperf

TEX_FILES = micperf_users_guide.pdf

all: $(TEX_FILES)

%.pdf: %.tex
	# generate table of content
	xelatex $<
	# generate final document
	xelatex $<

clean:
	rm -f $(TEX_FILES)

install: all
	$(INSTALL_d) $(DESTDIR)$(docdir)
	$(INSTALL_f) micperf_users_guide.pdf $(DESTDIR)$(docdir)

=== gemm/Makefile ===
##******************************************************************************
##  Copyright(C) 2011-2012 Intel Corporation. All Rights Reserved.
##
##  The source code, information  and  material ("Material") contained herein is
##  owned  by Intel Corporation or its suppliers or licensors, and title to such
##  Material remains  with Intel Corporation  or its suppliers or licensors. The
##  Material  contains proprietary information  of  Intel or  its  suppliers and
##  licensors. The  Material is protected by worldwide copyright laws and treaty
##  provisions. No  part  of  the  Material  may  be  used,  copied, reproduced,
##  modified, published, uploaded, posted, transmitted, distributed or disclosed
##  in any way  without Intel's  prior  express written  permission. No  license
##  under  any patent, copyright  or  other intellectual property rights  in the
##  Material  is  granted  to  or  conferred  upon  you,  either  expressly,  by
##  implication, inducement,  estoppel or  otherwise.  Any  license  under  such
##  intellectual  property  rights must  be express  and  approved  by  Intel in
##  writing.
##
##  *Third Party trademarks are the property of their respective owners.
##
##  Unless otherwise  agreed  by Intel  in writing, you may not remove  or alter
##  this  notice or  any other notice embedded  in Materials by Intel or Intel's
##  suppliers or licensors in any way.
##
##******************************************************************************
##  Content:
##      Makefile for SGEMM, DGEMM, CGEMM, ZGEMM benchmarks
##******************************************************************************

ICC		?= icc
TARGET_ICC	?= $(ICC)
INSTALL		?= install
VERSION		?= 0.0.0
prefix		?= /usr
exec_prefix	?= $(prefix)
libexecdir	?= $(exec_prefix)/libexec
datarootdir	?= $(prefix)/share
docdir		?= $(datarootdir)/doc
srcinstalldir	?= $(prefix)/src/micperf
card_libs ?= /opt/mpss/x200/minsdk/lib

all: knc

COMPOSER_VER = $(if $(findstring 2018, $(MKLROOT)),2018,2017)
ifeq ($(COMPOSER_VER),2018)
addprec = $(foreach x, s d i, $(x)$(strip $(1)))
else
addprec = $(foreach x, s d, $(x)$(strip $(1)))
endif

CPU_TARGETS	= $(call addprec, gemm_cpu.x)
MIC_TARGETS	= $(call addprec, gemm_mic.x)
OFL_TARGETS	= $(call addprec, gemm_ofl.x)
MCDRAM_CPU_TARGETS = $(call addprec, gemm_mcdram_cpu.x)
KNL_SNC_TARGETS = $(call addprec, gemm_mpi_snc_cpu.x)

TARGETS		= $(MIC_TARGETS) $(CPU_TARGETS) $(OFL_TARGETS) \
$(MCDRAM_CPU_TARGETS) $(KNL_SNC_TARGETS)

SOURCE          = bench.c bench.h main.c Makefile README.txt redist.txt utils.c utils.h cross_timer.h

# BASIC COMPILATION SETUP
MKL_CFLAGS	= -I$(MKLROOT)/include -qopenmp

# SETTING DYNAMIC=yes at make time forces dynamic linking with MKL
ifneq (yes,$(DYNAMIC))
WLSTATIC	= -Wl,-Bstatic
WLDYNAMIC	= -Wl,-Bdynamic
STATIC		= -Bstatic
DYNAMIC		= -Bdynamic
endif
MKL_LIBS	= $(WLSTATIC) -lmkl_intel_lp64 -Wl,--start-group \
                  -lmkl_intel_thread -lmkl_core $(WLDYNAMIC) -Wl,--end-group
MKL_LIBS_LINKER	= $(STATIC) -lmkl_intel_lp64 --start-group \
                  -lmkl_intel_thread -lmkl_core $(DYNAMIC) --end-group

K1OM_BIN_POSTFIX = /mic

MIC_CFLAGS	= $(MKL_CFLAGS) -qno-offload

CPU_CFLAGS	= $(MKL_CFLAGS) -qno-offload -D_GNU_SOURCE
CPU_LIBS	= -L$(MKLROOT)/lib/intel64 $(MKL_LIBS)

knc: OFL_CFLAGS	= $(MKL_CFLAGS)
knc: OFL_LIBS	= $(CPU_LIBS) -offload-option,mic,ld,"-L$(MKLROOT)/lib/mic $(MKL_LIBS_LINKER) --no-undefined"
knc: MIC_LIBS	= -L$(MKLROOT)/lib/mic $(MKL_LIBS)

knllb: OFL_CFLAGS = $(MKL_CFLAGS) -qoffload-arch=mic-avx512 -qoffload-option,mic,compiler,"-L$(card_libs)"
knllb: OFL_LIBS = $(CPU_LIBS) -qoffload-option,mic,ld,"-L$(MKLROOT)/lib/intel64 $(MKL_LIBS_LINKER) -L$(card_libs) --no-undefined" -qoffload-option,mic,link,"-rpath-link=$(card_libs)"
knllb: MIC_LIBS	= -L$(MKLROOT)/lib/intel64 $(MKL_LIBS)

ALL_CFLAGS	= -O2 -Wall -Werror -g -std=c99 -D_FORTIFY_SOURCE=2 -fstack-protector
EXTRA_LDFLAGS = -Wl,-z,relro,-z,now

# PRECISION OPTIONS SELECTION
s%.x	: PREC	= -DSINGLE_PREC
d%.x	: PREC	= -DDOUBLE_PREC
c%.x	: PREC	= -DCOMPLEX
z%.x	: PREC	= -DCOMPLEX16
i%.x    : PREC  = -DINTEGER

# ------- MKL ----------
$(MIC_TARGETS)	: CC		= $(TARGET_ICC)
$(MIC_TARGETS)	: EXTRA_CFLAGS	= $(MIC_CFLAGS)
$(MIC_TARGETS)	: LIBS		= $(MIC_LIBS)
$(CPU_TARGETS)	: CC		= $(ICC)
$(CPU_TARGETS)	: EXTRA_CFLAGS	= $(CPU_CFLAGS)
$(CPU_TARGETS)	: LIBS		= $(CPU_LIBS)
$(OFL_TARGETS)	: CC		= $(ICC)
$(OFL_TARGETS)	: EXTRA_CFLAGS	= $(OFL_CFLAGS)
$(OFL_TARGETS)	: LIBS		= $(OFL_LIBS)
$(MCDRAM_CPU_TARGETS): CC        = $(ICC)
$(MCDRAM_CPU_TARGETS): EXTRA_CFLAGS  = $(CPU_CFLAGS) -DMCDRAM_KNLSB
$(MCDRAM_CPU_TARGETS): LIBS      = $(CPU_LIBS) -lmemkind
$(KNL_SNC_TARGETS): CC		= mpiicc
$(KNL_SNC_TARGETS): EXTRA_CFLAGS  = $(CPU_CFLAGS) -DKNL_SNC_MODE
$(KNL_SNC_TARGETS): LIBS      = $(CPU_LIBS) -lnuma

# Optimize KNL binaries to use AVX512 and KNC card binaries for the k1om architecture
knc: MIC_CFLAGS += -mmic
knlsb: CPU_CFLAGS += -axMIC-AVX512,CORE-AVX512,SSE4.2
knllb: MIC_CFLAGS += -axMIC-AVX512

knc: mkl-x86_64 mkl-k1om

knlsb: $(CPU_TARGETS) $(MCDRAM_CPU_TARGETS) $(KNL_SNC_TARGETS)

knllb: mkl-x86_64 mkl-k1om

install: install-knc

install-knc: install-x86_64 install-k1om install-license

install-knlsb: $(CPU_TARGETS) $(MCDRAM_CPU_TARGETS) $(KNL_SNC_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) -d $(DESTDIR)$(docdir)

install-knllb: install-x86_64 install-x86_64-avx512 install-license

mkl-x86_64: $(OFL_TARGETS) $(CPU_TARGETS)

mkl-k1om: $(MIC_TARGETS)

install-x86_64: $(OFL_TARGETS) $(CPU_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64

install-k1om: $(MIC_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/k1om
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/k1om

install-x86_64-avx512: $(MIC_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

install-license:
	$(INSTALL) -d $(DESTDIR)$(docdir)

clean:
	-rm -rf $(TARGETS)

$(TARGETS): main.c bench.c bench.h utils.c utils.h cross_timer.h

%.x:
	$(CC) $(ALL_CFLAGS) $(CPPFLAGS) $(EXTRA_CFLAGS) $(CFLAGS) $(PREC) $(LDFLAGS) $(EXTRA_LDFLAGS) $(filter %.c, $^) $(LIBS) -o $@

.PHONY: all knc knlsb knllb mkl-x86_64 mkl-k1om mkl-ofl mkl-cpu mkl-mic clean install install-knc install-knlsb install-knllb install-x86_64 install-k1om

=== stream/Makefile ===
#
#Copyright (2011) Intel Corporation All Rights Reserved.
#
#The source code, information and material ("Material") contained
#herein is owned by Intel Corporation or its suppliers or licensors,
#and title to such Material remains with Intel Corporation or its
#suppliers or licensors. The Material contains proprietary information
#of Intel or its suppliers and licensors. The Material is protected by
#worldwide copyright laws and treaty provisions. No part of the
#Material may be used, copied, reproduced, modified, published,
#uploaded, posted, transmitted, distributed or disclosed in any way
#without Intel's prior express written permission. No license under any
#patent, copyright or other intellectual property rights in the
#Material is granted to or conferred upon you, either expressly, by
#implication, inducement, estoppel or otherwise. Any license under such
#intellectual property rights must be express and approved by Intel in
#writing.
#
#Unless otherwise agreed by Intel in writing, you may not remove or alter
#this notice or any other notice embedded in Materials by Intel or Intel's
#suppliers or licensors in any way.
#

ICC ?= icc
MPIICC ?= mpiicc -cc=$(ICC)
TARGET_ICC ?= $(ICC)
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
exec_prefix ?= $(prefix)
libexecdir ?= $(exec_prefix)/libexec
datarootdir ?= $(prefix)/share
docdir ?= $(datarootdir)/doc/micperf
srcinstalldir ?= $(prefix)/src/micperf

EXTRA_CFLAGS = -O3 -qopenmp -DSTREAM_ARRAY_SIZE=64000000 \
-qopt-streaming-stores always -restrict -fstack-protector -D_FORTIFY_SOURCE=2

EXTRA_LDFLAGS = -qopenmp -Wl,-z,relro,-z,now

all: knc

knc: stream_mic

stream: stream.c stream_mpi.c
stream_mpi: stream_mpi.c

knlsb: stream stream_mpi
knllb: stream_mic

# Optimize KNL binaries to use AVX512 and KNC card binaries for the k1om architecture
knc: MIC_CFLAGS = -mmic
knlsb: CPU_CFLAGS = -axMIC-AVX512
knllb: MIC_CFLAGS = -axMIC-AVX512

install: install-knc

install-knc: install-k1om install-license

install-knlsb: install-license knlsb
	# on a system where the micperf rpm is installed, sources will cause $(INSTALL) to fail, error can be suppressed.
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) stream $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) stream_mpi $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

install-knllb: install-x86_64-avx512 install-license

stream_mic: stream.c
	$(TARGET_ICC) $(MIC_CFLAGS) $(CPPFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $< \
		$(LDFLAGS) $(EXTRA_LDFLAGS) -o $@

stream:
	$(ICC) $(CPU_CFLAGS) $(CPPFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $< \
		$(LDFLAGS) $(EXTRA_LDFLAGS) -o $@
stream_mpi:
	$(MPIICC) $(CPU_CFLAGS) $(CPPFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $< \
                $(LDFLAGS) $(EXTRA_LDFLAGS) -o $@

install-k1om:
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/k1om
	$(INSTALL) stream_mic $(DESTDIR)$(libexecdir)/micperf/k1om

install-x86_64-avx512:
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) stream_mic $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

install-license:
	$(INSTALL) -d $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 license_stream.txt $(DESTDIR)$(docdir)

clean:
	-rm -rf stream_mic
	-rm -rf stream stream_mpi

.PHONY: all knc knlsb knllb install install-knc install-knlsb install-knllb clean install-k1om install-license

=== apps/sysdiag/ut/Makefile ===
PYTEST=py.test

all: sysdiag_ut

sysdiag_ut:
		export PYTHONPATH=$(pytest_installroot_sitepackages):$$PYTHONPATH; \
		export PYTHONPATH=../micp:$$PYTHONPATH; \
		$(PYTEST) --color=no -v

clean:
		rm -rf __pycache__
		rm -rf *.pyc


.PHONY: sysdiag_ut clean

=== apps/sysdiag/tools/cpu-info/Makefile ===
TOPDIR ?= ../../../..

-include $(TOPDIR)/common.mk

SYSDIAG_SRC_DIR = $(TOPDIR)/apps/sysdiag
SYSDIAG_TOOLS_SRC_DIR = $(SYSDIAG_SRC_DIR)/tools
SYSDIAG_MODULE_DIR ?= $(DATAROOTDIR)/$(proj_target)/sysdiag
CC ?= gcc
EXTRA_CFLAGS += $(CFLAGS) -Wall -Werror -Wextra -fPIC -fstack-protector -O2 -D_FORTIFY_SOURCE=2
EXTRA_LDFLAGS += $(LDFLAGS) -shared -Wl,-z,relro,-z,now
C_FILES = cpu-info.c
OBJ_FILES = $(C_FILES:.c=.o)
BIN_NAME = cpu-info
SO_NAME = cpu-info.so
BIN = $(SO_NAME)

ifdef DEBUG
    BIN = $(BIN_NAME)
    EXTRA_CFLAGS += -DDEBUG
    EXTRA_LDFLAGS = $(LDFLAGS)
endif

all : $(BIN)

$(BIN) : $(OBJ_FILES)
	$(CC) $(EXTRA_LDFLAGS) $(OBJ_FILES) -o $(BIN)

%.o : %.c
	$(CC) $(EXTRA_CFLAGS) -c $< -o $@

install : dirs
	$(INSTALL_x) $(SYSDIAG_TOOLS_SRC_DIR)/$(BIN_NAME)/$(BIN) $(DESTDIR)/$(SYSDIAG_MODULE_DIR)

dirs :
	$(INSTALL_d) $(DESTDIR)/$(SYSDIAG_MODULE_DIR)

clean :
	- rm -rf $(BIN_NAME) $(SO_NAME) $(OBJ_FILES)

.PHONY : all install dirs clean

=== deepbench/code/intel/convolution/Makefile ===
ICC ?= icc
TARGET_ICC ?= $(ICC)
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
exec_prefix ?= $(prefix)
libexecdir ?= $(exec_prefix)/libexec
datarootdir ?= $(prefix)/share
docdir ?= $(datarootdir)/doc/micperf
srcinstalldir ?= $(prefix)/src/micperf

all: mkl_conv libxsmm_conv
install: mkl_conv_install libxsmm_conv_install

mkl_conv:
	$(MAKE) -C mkl_conv all

libxsmm_conv:
	$(MAKE) -C libxsmm_conv/ libxsmm
	$(MAKE) -C libxsmm_conv/samples/dnn all

clean:
	$(MAKE) -C mkl_conv clean
	$(MAKE) -C libxsmm_conv clean

libxsmm_conv_install:
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) libxsmm_conv/samples/dnn/layer_example_f32 $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

mkl_conv_install:
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) mkl_conv/std_conv_bench $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

.PHONY: all install clean \
	mkl_conv libxsmm_conv \
	libxsmm_conv_install mkl_conv_install

=== deepbench/code/intel/convolution/libxsmm_conv/tests/Makefile ===
# Export all variables to sub-make processes.
#.EXPORT_ALL_VARIABLES: #export

# Automatically disable parallel builds
# depending on the version of GNU Make.
# MAKE_PARALLEL=0: disable explicitly
# MAKE_PARALLEL=1: enable explicitly
ifeq (0,$(MAKE_PARALLEL))
.NOTPARALLEL:
else ifeq (,$(MAKE_PARALLEL))
ifneq (3.82,$(firstword $(sort $(MAKE_VERSION) 3.82)))
.NOTPARALLEL:
endif
endif

ROOTDIR = $(abspath $(dir $(firstword $(MAKEFILE_LIST))))
DEPDIR = $(ROOTDIR)/..
SRCDIR = $(ROOTDIR)
INCDIR = $(ROOTDIR)
BLDDIR = build
OUTDIR = .

CXXFLAGS = $(NULL)
CFLAGS = $(NULL)
DFLAGS = $(NULL)
IFLAGS = -I$(INCDIR) -I$(DEPDIR)/include -I$(DEPDIR)/src

BLAS ?= 1
OMP ?= 1
SYM ?= 1

# include common Makefile artifacts
include $(DEPDIR)/Makefile.inc

OUTNAME := $(shell basename $(ROOTDIR))
HEADERS := $(wildcard $(INCDIR)/*.h) $(wildcard $(INCDIR)/*.hpp) $(wildcard $(INCDIR)/*.hxx) $(wildcard $(INCDIR)/*.hh) \
           $(wildcard $(SRCDIR)/*.h) $(wildcard $(SRCDIR)/*.hpp) $(wildcard $(SRCDIR)/*.hxx) $(wildcard $(SRCDIR)/*.hh)
CPPSRCS := $(shell grep -L $(CMAIN) $(SRCDIR)/*.cpp 2> /dev/null | tr "\n" " ")
CPPSRCX := $(shell grep -l $(CMAIN) $(SRCDIR)/*.cpp 2> /dev/null | tr "\n" " ")
CXXSRCS := $(shell grep -L $(CMAIN) $(SRCDIR)/*.cxx 2> /dev/null | tr "\n" " ")
CXXSRCX := $(shell grep -l $(CMAIN) $(SRCDIR)/*.cxx 2> /dev/null | tr "\n" " ")
CCXSRCS := $(shell grep -L $(CMAIN) $(SRCDIR)/*.cc  2> /dev/null | tr "\n" " ")
CCXSRCX := $(shell grep -l $(CMAIN) $(SRCDIR)/*.cc  2> /dev/null | tr "\n" " ")
CSOURCS := $(shell grep -L $(CMAIN) $(SRCDIR)/*.c   2> /dev/null | tr "\n" " ")
CSOURCX := $(shell grep -l $(CMAIN) $(SRCDIR)/*.c   2> /dev/null | tr "\n" " ")
FXXSRCS := $(shell grep -L $(FMAIN) $(SRCDIR)/*.f   2> /dev/null | tr "\n" " ")
FXXSRCX := $(shell grep -l $(FMAIN) $(SRCDIR)/*.f   2> /dev/null | tr "\n" " ")
F77SRCS := $(shell grep -L $(FMAIN) $(SRCDIR)/*.F   2> /dev/null | tr "\n" " ")
F77SRCX := $(shell grep -l $(FMAIN) $(SRCDIR)/*.F   2> /dev/null | tr "\n" " ")
F90SRCS := $(shell grep -L $(FMAIN) $(SRCDIR)/*.f90 2> /dev/null | tr "\n" " ") \
           $(shell grep -L $(FMAIN) $(SRCDIR)/*.F90 2> /dev/null | tr "\n" " ")
F90SRCX := $(shell grep -l $(FMAIN) $(SRCDIR)/*.f90 2> /dev/null | tr "\n" " ") \
           $(shell grep -l $(FMAIN) $(SRCDIR)/*.F90 2> /dev/null | tr "\n" " ")
MODULES := $(addsuffix    .mod,$(basename $(FXXSRCS) $(F77SRCS) $(F90SRCS))) \
           $(addsuffix .modmic,$(basename $(FXXSRCS) $(F77SRCS) $(F90SRCS)))
OBJECTS := $(call objname, $(CPPSRCS) $(CXXSRCS) $(CCXSRCS) $(CSOURCS))
OBJECTX := $(call objname, $(CPPSRCX) $(CXXSRCX) $(CCXSRCX) $(CSOURCX))
FTNOBJS := $(call objname, $(FXXSRCS) $(F77SRCS) $(F90SRCS))
FTNOBJX := $(call objname, $(FXXSRCX) $(F77SRCX) $(F90SRCX))
XFILES  := $(addprefix $(OUTDIR)/,$(basename $(notdir \
           $(CPPSRCX) $(CXXSRCX) $(CCXSRCX) $(CSOURCX) \
           $(FXXSRCX) $(F77SRCX) $(F90SRCX))))

.PHONY: all
all: $(XFILES)

.PHONY: compile
compile: $(OBJECTS) $(FTNOBJS)

.PHONY: tests
tests: test

.PHONY: test
test: $(OUTDIR)/.make $(OUTDIR)/test.sh $(XFILES)
	@$(OUTDIR)/test.sh $(TEST)

TEST_NOBLASLIB = $(call abslib, $(LIBNAME)noblas.$(LIBEXT))
ifneq (Darwin,$(UNAME))
  TEST_EXTLIB = $(EXTLIB)
endif

define DEFINE_LINK_LD_RULE
ifneq (,$(wildcard $(LIBNAME).$(LIBEXT)))
ifneq (,$(wildcard $(LIBNAME)ext.$(LIBEXT)))
$(1): $(2) $(call objname, $(CPPSRCS) $(CXXSRCS) $(CCXSRCS) $(CSOURCS)) $(LIBNAME).$(LIBEXT) $(LIBNAME)ext.$(LIBEXT) $(dir $(1))/.make
ifneq (0,$(BLAS))
	$(LD) $(SLDFLAGS) -o $(1) $(2) $(TEST_EXTLIB) $(call abslib, $(LIBNAME).$(LIBEXT)) $(LDFLAGS) $(CLDFLAGS)
else
	$(LD) $(SLDFLAGS) -o $(1) $(2) $(call abslib, $(LIBNAME).$(LIBEXT)) $(TEST_EXTLIB) $(TEST_NOBLASLIB) $(LDFLAGS) $(CLDFLAGS)
endif
else
.PHONY: $(1)
endif
else
.PHONY: $(1)
endif
endef

define DEFINE_LINK_FC_RULE
ifneq (,$(strip $(FC)))
ifneq (,$(wildcard $(LIBNAME).$(LIBEXT)))
ifneq (,$(wildcard $(LIBNAME)f.$(LIBEXT)))
ifneq (,$(wildcard $(LIBNAME)ext.$(LIBEXT)))
$(1): $(2) $(call objname, $(FXXSRCS) $(F77SRCS) $(F90SRCS)) $(LIBNAME)f.$(LIBEXT) $(LIBNAME).$(LIBEXT) $(LIBNAME)ext.$(LIBEXT) $(dir $(1))/.make
ifneq (0,$(BLAS))
	$(FC) $(SLDFLAGS) -o $(1) $(2) $(call abslib, $(LIBNAME)f.$(LIBEXT)) $(TEST_EXTLIB) \
		$(call abslib, $(LIBNAME).$(LIBEXT)) $(FCMTFLAGS) $(LDFLAGS) $(FLDFLAGS) $(ELDFLAGS)
else
	$(FC) $(SLDFLAGS) -o $(1) $(2) $(call abslib, $(LIBNAME)f.$(LIBEXT)) $(call abslib, $(LIBNAME).$(LIBEXT)) $(TEST_EXTLIB) \
		$(TEST_NOBLASLIB) $(FCMTFLAGS) $(LDFLAGS) $(FLDFLAGS) $(ELDFLAGS)
endif
else
.PHONY: $(1)
endif
else
.PHONY: $(1)
endif
else
.PHONY: $(1)
endif
else
.PHONY: $(1)
endif
endef

$(foreach SRC, $(CPPSRCX) $(CXXSRCX) $(CCXSRCX) $(CSOURCX),$(eval $(call DEFINE_LINK_LD_RULE, \
  $(basename $(notdir $(SRC))), $(call objname, $(SRC)))))

$(foreach SRC, $(FXXSRCX) $(F77SRCX) $(F90SRCX),$(eval $(call DEFINE_LINK_FC_RULE, \
  $(basename $(notdir $(SRC))), $(call objname, $(SRC)))))

$(OUTDIR)/headeronly: $(OUTDIR)/.make $(BLDDIR)/headeronly-c.o $(BLDDIR)/headeronly_aux-c.o
	$(LD) -o $@ $(BLDDIR)/headeronly-c.o $(BLDDIR)/headeronly_aux-c.o $(SLDFLAGS) $(LDFLAGS) $(CLDFLAGS)

$(BLDDIR)/%-cpp.o: $(SRCDIR)/%.cpp .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc $(DEPDIR)/include/libxsmm_source.h
	$(CXX) $(CXXFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-c.o: $(SRCDIR)/%.c .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc $(DEPDIR)/include/libxsmm_source.h
	$(CC) $(CFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-f.o: $(SRCDIR)/%.f .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc $(DEPDIR)/include/libxsmm_source.h
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.f90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc $(DEPDIR)/include/libxsmm_source.h
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.F90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc $(DEPDIR)/include/libxsmm_source.h
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f77.o: $(SRCDIR)/%.F .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc $(DEPDIR)/include/libxsmm_source.h
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

.PHONY: clean
clean:
ifneq ($(abspath $(BLDDIR)),$(ROOTDIR))
ifneq ($(abspath $(BLDDIR)),$(abspath .))
	@rm -rf $(BLDDIR)
endif
endif
ifneq (,$(wildcard $(BLDDIR))) # still exists
	@rm -f $(OBJECTS) $(OBJECTX) $(FTNOBJS) $(FTNOBJX) *__genmod.* fit.log *.dat *.mhd
	@rm -f $(BLDDIR)/*.gcno $(BLDDIR)/*.gcda $(BLDDIR)/*.gcov
endif
	@rm -f .make .state

.PHONY: realclean
realclean: clean
ifneq ($(abspath $(OUTDIR)),$(ROOTDIR))
ifneq ($(abspath $(OUTDIR)),$(abspath .))
	@rm -rf $(OUTDIR)
endif
endif
ifneq (,$(wildcard $(OUTDIR))) # still exists
	@rm -f $(OUTDIR)/libxsmm.$(DLIBEXT) $(OUTDIR)/*.stackdump
	@rm -f $(XFILES) $(MODULES)
endif

=== deepbench/code/intel/convolution/libxsmm_conv/samples/blkgemm/Makefile ===
# Export all variables to sub-make processes.
#.EXPORT_ALL_VARIABLES: #export

# Automatically disable parallel builds
# depending on the version of GNU Make.
# MAKE_PARALLEL=0: disable explicitly
# MAKE_PARALLEL=1: enable explicitly
ifeq (0,$(MAKE_PARALLEL))
.NOTPARALLEL:
else ifeq (,$(MAKE_PARALLEL))
ifneq (3.82,$(firstword $(sort $(MAKE_VERSION) 3.82)))
.NOTPARALLEL:
endif
endif

ROOTDIR = $(abspath $(dir $(firstword $(MAKEFILE_LIST))))
DEPDIR = ../..
SRCDIR = $(ROOTDIR)
INCDIR = .
BLDDIR = .
OUTDIR = .

CXXFLAGS = $(NULL)
CFLAGS = $(NULL)
DFLAGS = $(NULL)
IFLAGS = -I$(INCDIR) -I$(DEPDIR)/include

BLAS = 1
OMP = 0
SYM = 1

# include common Makefile artifacts
include $(DEPDIR)/Makefile.inc

OUTNAME := $(shell basename $(ROOTDIR))
HEADERS := $(wildcard $(INCDIR)/*.h) $(wildcard $(INCDIR)/*.hpp) $(wildcard $(INCDIR)/*.hxx) $(wildcard $(INCDIR)/*.hh) \
           $(wildcard $(SRCDIR)/*.h) $(wildcard $(SRCDIR)/*.hpp) $(wildcard $(SRCDIR)/*.hxx) $(wildcard $(SRCDIR)/*.hh)
CPPSRCS := $(wildcard $(SRCDIR)/*.cpp)
CXXSRCS := $(wildcard $(SRCDIR)/*.cxx)
CCXSRCS := $(wildcard $(SRCDIR)/*.cx)
CSOURCS := $(wildcard $(SRCDIR)/*.c)
FXXSRCS := $(wildcard $(SRCDIR)/*.f)
F77SRCS := $(wildcard $(SRCDIR)/*.F)
F90SRCS := $(wildcard $(SRCDIR)/*.f90) $(wildcard $(SRCDIR)/*.F90)
CPPOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CPPSRCS:.cpp=-cpp.o)))
CXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CXXSRCS:.cxx=-cxx.o)))
CCXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CCXSRCS:.cc=-cc.o)))
COBJCTS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CSOURCS:.c=-c.o)))
FXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(FXXSRCS:.f=-f.o)))
F77OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F77SRCS:.F=-f77.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90SRCS:.f90=-f90.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90OBJS:.F90=-f90.o)))
SOURCES := $(CPPSRCS) $(CXXSRCS) $(CCXSRCS) $(CSOURCS)
OBJECTS := $(CPPOBJS) $(CXXOBJS) $(CCXOBJS) $(COBJCTS)
FTNSRCS := $(FXXSRCS) $(F77SRCS) $(F90SRCS)
MODULES := $(addsuffix .mod,$(basename $(FTNSRCS))) $(addsuffix .modmic,$(basename $(FTNSRCS)))
FTNOBJS := $(FXXOBJS) $(F77OBJS) $(F90OBJS)
XFILES := $(OUTDIR)/block_gemm

.PHONY: all
all: $(XFILES)

.PHONY: compile
compile: $(OBJECTS) $(FTNOBJS)

$(OUTDIR)/block_gemm: $(OUTDIR)/.make $(BLDDIR)/block_gemm-c.o $(LIBNAME).$(LIBEXT)
	$(LD) -o $@ $(BLDDIR)/block_gemm-c.o $(call abslib,$(LIBNAME).$(LIBEXT)) $(SLDFLAGS) $(LDFLAGS) $(CLDFLAGS)

$(BLDDIR)/%-cpp.o: $(SRCDIR)/%.cpp .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CXX) $(CXXFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-c.o: $(SRCDIR)/%.c .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CC) $(CFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

.PHONY: clean
clean:
ifneq ($(abspath $(BLDDIR)),$(ROOTDIR))
ifneq ($(abspath $(BLDDIR)),$(abspath .))
	@rm -rf $(BLDDIR)
endif
endif
ifneq (,$(wildcard $(BLDDIR))) # still exists
	@rm -f $(OBJECTS) $(OBJECTX) $(FTNOBJS) $(FTNOBJX) *__genmod.* fit.log *.dat *.mhd
	@rm -f $(BLDDIR)/*.gcno $(BLDDIR)/*.gcda $(BLDDIR)/*.gcov
endif
	@rm -f .make .state

.PHONY: realclean
realclean: clean
ifneq ($(abspath $(OUTDIR)),$(ROOTDIR))
ifneq ($(abspath $(OUTDIR)),$(abspath .))
	@rm -rf $(OUTDIR)
endif
endif
ifneq (,$(wildcard $(OUTDIR))) # still exists
	@rm -f $(OUTDIR)/libxsmm.$(DLIBEXT) $(OUTDIR)/*.stackdump
	@rm -f $(XFILES) $(MODULES)
endif

=== deepbench/code/intel/convolution/libxsmm_conv/samples/cp2k/Makefile ===
# Export all variables to sub-make processes.
#.EXPORT_ALL_VARIABLES: #export

# Automatically disable parallel builds
# depending on the version of GNU Make.
# MAKE_PARALLEL=0: disable explicitly
# MAKE_PARALLEL=1: enable explicitly
ifeq (0,$(MAKE_PARALLEL))
.NOTPARALLEL:
else ifeq (,$(MAKE_PARALLEL))
ifneq (3.82,$(firstword $(sort $(MAKE_VERSION) 3.82)))
.NOTPARALLEL:
endif
endif

ROOTDIR = $(abspath $(dir $(firstword $(MAKEFILE_LIST))))
DEPDIR = ../..
SRCDIR = $(ROOTDIR)
INCDIR = .
BLDDIR = build
OUTDIR = .

CXXFLAGS = $(NULL)
CFLAGS = $(NULL)
DFLAGS = $(NULL)
IFLAGS = -I$(INCDIR) -I$(DEPDIR)/include

BLAS = 1
OMP = 1
SYM = 1

# include common Makefile artifacts
include $(DEPDIR)/Makefile.inc

OUTNAME := $(shell basename $(ROOTDIR))
HEADERS := $(wildcard $(INCDIR)/*.h) $(wildcard $(INCDIR)/*.hpp) $(wildcard $(INCDIR)/*.hxx) $(wildcard $(INCDIR)/*.hh) \
           $(wildcard $(SRCDIR)/*.h) $(wildcard $(SRCDIR)/*.hpp) $(wildcard $(SRCDIR)/*.hxx) $(wildcard $(SRCDIR)/*.hh)
CPPSRCS := $(wildcard $(SRCDIR)/*.cpp)
CXXSRCS := $(wildcard $(SRCDIR)/*.cxx)
CCXSRCS := $(wildcard $(SRCDIR)/*.cx)
CSOURCS := $(wildcard $(SRCDIR)/*.c)
FXXSRCS := $(wildcard $(SRCDIR)/*.f)
F77SRCS := $(wildcard $(SRCDIR)/*.F)
F90SRCS := $(wildcard $(SRCDIR)/*.f90) $(wildcard $(SRCDIR)/*.F90)
CPPOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CPPSRCS:.cpp=-cpp.o)))
CXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CXXSRCS:.cxx=-cxx.o)))
CCXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CCXSRCS:.cc=-cc.o)))
COBJCTS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CSOURCS:.c=-c.o)))
FXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(FXXSRCS:.f=-f.o)))
F77OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F77SRCS:.F=-f77.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90SRCS:.f90=-f90.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90OBJS:.F90=-f90.o)))
SOURCES := $(CPPSRCS) $(CXXSRCS) $(CCXSRCS) $(CSOURCS)
OBJECTS := $(CPPOBJS) $(CXXOBJS) $(CCXOBJS) $(COBJCTS)
FTNSRCS := $(FXXSRCS) $(F77SRCS) $(F90SRCS)
MODULES := $(addsuffix .mod,$(basename $(FTNSRCS))) $(addsuffix .modmic,$(basename $(FTNSRCS)))
FTNOBJS := $(FXXOBJS) $(F77OBJS) $(F90OBJS)
XFILES := $(OUTDIR)/$(OUTNAME)

.PHONY: all
all: $(XFILES)

.PHONY: compile
compile: $(OBJECTS) $(FTNOBJS)

$(OUTDIR)/$(OUTNAME): $(OUTDIR)/.make $(OBJECTS) $(LIBNAME).$(LIBEXT) $(LIBNAME)ext.$(LIBEXT)
	$(XLD) -o $@ $(OBJECTS) $(call abslib,$(LIBNAME).$(LIBEXT)) $(SLDFLAGS) $(LDFLAGS) $(CLDFLAGS)

$(BLDDIR)/%-cpp.o: $(SRCDIR)/%.cpp .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CXX) $(CXXFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-c.o: $(SRCDIR)/%.c .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CC) $(CFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-f.o: $(SRCDIR)/%.f .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.f90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.F90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f77.o: $(SRCDIR)/%.F .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

.PHONY: clean
clean:
ifneq ($(abspath $(BLDDIR)),$(ROOTDIR))
ifneq ($(abspath $(BLDDIR)),$(abspath .))
	@rm -rf $(BLDDIR)
endif
endif
ifneq (,$(wildcard $(BLDDIR))) # still exists
	@rm -f $(OBJECTS) $(OBJECTX) $(FTNOBJS) $(FTNOBJX) *__genmod.* fit.log *.dat *.mhd
	@rm -f $(BLDDIR)/*.gcno $(BLDDIR)/*.gcda $(BLDDIR)/*.gcov
endif
	@rm -f .make .state

.PHONY: realclean
realclean: clean
ifneq ($(abspath $(OUTDIR)),$(ROOTDIR))
ifneq ($(abspath $(OUTDIR)),$(abspath .))
	@rm -rf $(OUTDIR)
endif
endif
ifneq (,$(wildcard $(OUTDIR))) # still exists
	@rm -f $(OUTDIR)/libxsmm.$(DLIBEXT) $(OUTDIR)/*.stackdump
	@rm -f $(XFILES) $(MODULES)
endif

=== deepbench/code/intel/convolution/libxsmm_conv/samples/dispatch/Makefile ===
# Export all variables to sub-make processes.
#.EXPORT_ALL_VARIABLES: #export

# Automatically disable parallel builds
# depending on the version of GNU Make.
# MAKE_PARALLEL=0: disable explicitly
# MAKE_PARALLEL=1: enable explicitly
ifeq (0,$(MAKE_PARALLEL))
.NOTPARALLEL:
else ifeq (,$(MAKE_PARALLEL))
ifneq (3.82,$(firstword $(sort $(MAKE_VERSION) 3.82)))
.NOTPARALLEL:
endif
endif

ROOTDIR = $(abspath $(dir $(firstword $(MAKEFILE_LIST))))
DEPDIR = ../..
SRCDIR = $(ROOTDIR)
INCDIR = .
BLDDIR = build
OUTDIR = .

CXXFLAGS = $(NULL)
CFLAGS = $(NULL)
DFLAGS = $(NULL)
IFLAGS = -I$(INCDIR) -I$(DEPDIR)/include

BLAS = 1
SYM = 1

# include common Makefile artifacts
include $(DEPDIR)/Makefile.inc

OUTNAME := $(shell basename $(ROOTDIR))
HEADERS := $(wildcard $(INCDIR)/*.h) $(wildcard $(INCDIR)/*.hpp) $(wildcard $(INCDIR)/*.hxx) $(wildcard $(INCDIR)/*.hh) \
           $(wildcard $(SRCDIR)/*.h) $(wildcard $(SRCDIR)/*.hpp) $(wildcard $(SRCDIR)/*.hxx) $(wildcard $(SRCDIR)/*.hh)
CPPSRCS := $(wildcard $(SRCDIR)/*.cpp)
CXXSRCS := $(wildcard $(SRCDIR)/*.cxx)
CCXSRCS := $(wildcard $(SRCDIR)/*.cx)
CSOURCS := $(wildcard $(SRCDIR)/*.c)
FXXSRCS := $(wildcard $(SRCDIR)/*.f)
F77SRCS := $(wildcard $(SRCDIR)/*.F)
F90SRCS := $(wildcard $(SRCDIR)/*.f90) $(wildcard $(SRCDIR)/*.F90)
CPPOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CPPSRCS:.cpp=-cpp.o)))
CXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CXXSRCS:.cxx=-cxx.o)))
CCXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CCXSRCS:.cc=-cc.o)))
COBJCTS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CSOURCS:.c=-c.o)))
FXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(FXXSRCS:.f=-f.o)))
F77OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F77SRCS:.F=-f77.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90SRCS:.f90=-f90.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90OBJS:.F90=-f90.o)))
SOURCES := $(CPPSRCS) $(CXXSRCS) $(CCXSRCS) $(CSOURCS)
OBJECTS := $(CPPOBJS) $(CXXOBJS) $(CCXOBJS) $(COBJCTS)
FTNSRCS := $(FXXSRCS) $(F77SRCS) $(F90SRCS)
MODULES := $(addsuffix .mod,$(basename $(FTNSRCS))) $(addsuffix .modmic,$(basename $(FTNSRCS)))
FTNOBJS := $(FXXOBJS) $(F77OBJS) $(F90OBJS)
XFILES := $(OUTDIR)/$(OUTNAME) $(OUTDIR)/$(OUTNAME)f

.PHONY: all
all: $(XFILES)

.PHONY: compile
compile: $(OBJECTS) $(FTNOBJS)

ifneq (,$(strip $(FC)))
$(OUTDIR)/$(OUTNAME)f: $(OUTDIR)/.make $(FTNOBJS) $(LIBNAME)f.$(LIBEXT) $(LIBNAME)ext.$(LIBEXT) $(LIBNAME).$(LIBEXT)
	$(FC) -o $@ $(FTNOBJS) $(EXTLIB) $(call abslib,$(LIBNAME)f.$(LIBEXT)) $(call abslib,$(LIBNAME).$(LIBEXT)) \
		$(FCMTFLAGS) $(SLDFLAGS) $(LDFLAGS) $(FLDFLAGS) $(ELDFLAGS)
else
.PHONY: $(OUTDIR)/$(OUTNAME)f
endif

$(OUTDIR)/$(OUTNAME): $(OUTDIR)/.make $(OBJECTS) $(LIBNAME).$(LIBEXT) $(LIBNAME)ext.$(LIBEXT)
	$(LD) -o $@ $(OBJECTS) $(call abslib,$(LIBNAME).$(LIBEXT)) $(SLDFLAGS) $(LDFLAGS) $(CLDFLAGS)

$(BLDDIR)/%-cpp.o: $(SRCDIR)/%.cpp .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CXX) $(CXXFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-c.o: $(SRCDIR)/%.c .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CC) $(CFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-f.o: $(SRCDIR)/%.f .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.f90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.F90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f77.o: $(SRCDIR)/%.F .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

.PHONY: clean
clean:
ifneq ($(abspath $(BLDDIR)),$(ROOTDIR))
ifneq ($(abspath $(BLDDIR)),$(abspath .))
	@rm -rf $(BLDDIR)
endif
endif
ifneq (,$(wildcard $(BLDDIR))) # still exists
	@rm -f $(OBJECTS) $(OBJECTX) $(FTNOBJS) $(FTNOBJX) *__genmod.* fit.log *.dat *.mhd
	@rm -f $(BLDDIR)/*.gcno $(BLDDIR)/*.gcda $(BLDDIR)/*.gcov
endif
	@rm -f .make .state

.PHONY: realclean
realclean: clean
ifneq ($(abspath $(OUTDIR)),$(ROOTDIR))
ifneq ($(abspath $(OUTDIR)),$(abspath .))
	@rm -rf $(OUTDIR)
endif
endif
ifneq (,$(wildcard $(OUTDIR))) # still exists
	@rm -f $(OUTDIR)/libxsmm.$(DLIBEXT) $(OUTDIR)/*.stackdump
	@rm -f $(XFILES) $(MODULES)
endif

=== changelog ===
zonesort (1.0+xpps-2.3.0.482) artful-xpps; urgency=low

  * The zonesort module CI build.

 -- Intel Corporation <https://supporttickets.intel.com>  Wed, 31 Jan 2018 09:25:23 +0000

zonesort (1.0+xpps-1) unstable; urgency=low

  * Inititial zonesort release for Intel(R) Xeon Phi(TM) processor software.

 -- Adam Lessnau <adam.lessnau@intel.com>  Mon, 30 Oct 2017 12:31:55 +0100

=== debian/changelog ===
memkind (1.7.0+xpps-2.3.0.482) artful-xpps; urgency=low

  * The memkind source code used by the XPPS release.
  * See ChangeLog for more details.

 -- Intel Corporation <https://supporttickets.intel.com>  Wed, 31 Jan 2018 09:25:21 +0000

=== debian/control ===
Source: sysdiag
Origin: Intel(R) Xeon Phi(TM) processor software
Maintainer: Intel Corporation <https://supporttickets.intel.com>
Section: utils
Priority: optional
Standards-Version: 3.9.4
Build-Depends: python (>= 2.7), dh-python, debhelper (>= 9)
X-Python-Version: >= 2.7

Package: sysdiag
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, numactl
Description: Intel(R) Xeon Phi(TM) processor diagnosing tool
 The SysDiag tool provides a variety of information and diagnostics
 for the processor.  SysDiag also monitors DDR, MCDRAM and PCI-E
 information. It also monitors temperature  and performance state
 data of the CPU.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PYBUILD_SYSTEM=custom
export PYBUILD_DISABLE=clean configure
export PYBUILD_BUILD_ARGS=make knlsb VERSION=2.3.0+xpps-2.3.0.482
export PYBUILD_INSTALL_ARGS=make install-knlsb VERSION=2.3.0+xpps-2.3.0.482 DESTDIR={destdir}

PACKAGE_NAME = micperf

%:
	dh $@ --with python2 --buildsystem=pybuild

# Ignore external icc dependencies
override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info
